#ifndef __ASM__VSYSCALL_H
#define __ASM__VSYSCALL_H
/* include/asm-i386/vsyscall.h
 *	Copyright 2002 Red Hat, Inc.
 */
#include <linux/linkage.h>
#include <asm/unistd.h>

/* We call sys_dynamic_syscall(long nr, void *args) using regparm(2)
 * convention.  The .text.vsyscall section is mapped into userspace, 
 * whereas .data.vsyscall_list is a kernel-only array of the vsyscalls 
 * and the valid userspace address to call them from.  All vsyscalls 
 * are called with C calling convention (ie args on the stack for x86).
 *
 * Note: the layout of .data.vsyscall_list must match the entries in
 * dynamic_syscall.c.
 */
#define STRINGIFYa(x)	#x
#define STRINGIFY(x)	STRINGIFYa(x)
#define NR_dyn_sys	STRINGIFY(__NR_sys_dynamic_syscall)
#define add_dynamic_syscall(name)				\
	__asm__("						\n\
	.section .vsyscall_text, \"xa\"				\n\
	.globl v" #name "					\n\
	v" #name ":						\n\
		push %ecx					\n\
		push %edx					\n\
		movl $" NR_dyn_sys ",%eax			\n\
		movl $2f,%edx					\n\
		leal 12(%esp),%ecx				\n\
		int $0x80					\n\
	1:							\n\
		popl %edx					\n\
		popl %ecx					\n\
		ret						\n\
	.size v" #name ",.-v" #name "				\n\
	.previous						\n\
	.section .data.vsyscall_list,\"a\"			\n\
	2:	.long	1b," #name "				\n\
	.previous")

#endif
